#include <stdio.h>
#include <stdlib.h>

#define MAX_n 100
#define INF 1000000

int min (int a, int b) {
  return (a <= b ? a : b);
}

int moneda (int * d, int n, int k, int * r) {
  int m[n+1][k+1];
  int i, j;
  for (i = 0; i <= n; i++) m[i][0] = 0;
  for (j = 1; j <= k; j++) m[0][j] = INF;
  for (i = 1; i <= n; i++) {
     for (j = 1; j <= k; j++) {
        m[i][j] = d[i] > j ? m[i-1][j] : min(m[i-1][j],1+m[i][j-d[i]]);
     }
  }

  // Ahora m[n][k] es el número de monedas, recuperemos cuáles son las monedas
  for (i = 1; i <= n; i++) r[i] = 0; 
  if (m[n][k] < INF) {
    i = n;
    j = k;
    while (j > 0) {
      if (m[i][j] < m[i-1][j]) {
        r[i] = r[i]+1;
        j = j - d[i];
      } else {
        i--;
      }
    }
  }
  return m[n][k];
}

int main (int argc, char *argv[]) {
  int d[MAX_n+1]; // desperdicio la celda d[0] para facilitar la lectura
  int r[MAX_n+1]; // desperdicio la celda r[0] para facilitar la lectura
  int i;

  int k = atoi(argv[argc-1]);
  int n = argc - 2;

  if (n < 1 || n > MAX_n) {
    printf("Wrong number of arguments.\n");
    return 0;
  }

  for (i = 1; i <= n; i++) d[i] = atoi(argv[i]);

  printf("%d\n",moneda(d,n,k,r));

  for (i = 1; i <= n; i++) printf("%d:%d, ",d[i],r[i]);
  printf("\n");

  return 1;
}

